=== debian/changelog ===
elastix (4.8-12build1) artful; urgency=medium

  * No-change rebuild against libinsighttoolkit4.12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 24 Aug 2017 06:24:18 +0000

elastix (4.8-12) unstable; urgency=medium

  * d/p/itk4.11.patch: Make it compile with itk >= 4.11
  * d/control: Update my maintainer e-mail 
  * d/control: Update standards vesrsion

 -- Gert Wollny <gewo@debian.org>  Fri, 14 Jul 2017 10:05:14 +0000

elastix (4.8-11) unstable; urgency=medium

  * Team upload
  * Moved packaging from SVN to Git
  * Drop myself from Uploaders
  * debian/upstream/metadata: Add more recent publication
  * d/watch: point to Github
  * debhelper 10
  * Drop latex-xcolor which is in texlive-latex-recommended
    Closes: #865258
  * d/rules: xz compression is now default
  * avoid privacy breach by using local logo

 -- Andreas Tille <tille@debian.org>  Tue, 20 Jun 2017 10:05:20 +0200

elastix (4.8-10) unstable; urgency=medium

  * d/p/itk-4.10: Add patch to compile with ITK-4.10

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 25 Jul 2016 18:46:29 +0000

elastix (4.8-9) unstable; urgency=medium

  * d/p/fix-compi..: fix compilation with -std=c++11, 
  * d/rules: removed forced std=c++03, Closes: #822779
  * d/rules: hardening += all 
  * d/control: use secure VCS browse url 

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 06 Jul 2016 12:45:21 +0000

elastix (4.8-8) unstable; urgency=medium

  * d/rules: force -std=c++03 to alleviate build failure with g++-6.0
    Related: #822713

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 26 Apr 2016 21:04:29 +0000

elastix (4.8-7) unstable; urgency=medium

  * d/control: Update to latest standards version 3.9.8 

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 26 Apr 2016 15:08:45 +0000

elastix (4.8-6) unstable; urgency=medium

  * d/rules: add another sed to remove the \today from manual.tex

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 21 Mar 2016 17:24:01 +0000

elastix (4.8-5) unstable; urgency=medium

  * d/control: Add texlive-publishers to doc-build depends as it seems to be 
    needed for the references
  * d/rules: Update the build script for the manual.pdf to make use of
    SOURCE_DATE_EPOCH when building it. 
  * d/control: Update standards version to 3.9.7

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 16 Mar 2016 15:41:26 +0000

elastix (4.8-4) unstable; urgency=medium

  * d/p: Update date-time patch Closes: #813345
  * d/control: update standards version to 3.9.7
  * d/control: update VCS browse URL to use https

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 07 Mar 2016 13:30:50 +0000

elastix (4.8-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/fix-cast-error.patch:
    fix FTBFS with insighttoolkit4.9 (Closes: #815996).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Feb 2016 12:54:10 +0100

elastix (4.8-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Add Registration field to upstream metadata

  [ Gert Wollny ]
  * Update dependency for libdcmtk-dev to unversioned package
  * Rebuild against itk-4.8.2-3, Closes: #650601

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 07 Jan 2016 12:49:31 +0100

elastix (4.8-2) unstable; urgency=medium

  * d/rules: - Revert the change regarding jquery.js, the system 
               version is not usable 
             - Add SOURCE_DATE_EPOCH to the cmake call parameters
  * d/ add override to elastix-doc for embedded jquery.js
  * Add and unify patch for doxygen docu cleanup in 
    doxygen_cleanup.patch: 
    - Remove the google search and make local links point to the 
      remote elastix site like it is suppose to.
    - Move the Google analytics patch into this patch 
    - Move the patch for PNG->SVG change into this patch 
    - enable the SEARCHENGINE since this issues the needed 
      dynsections.js 
  * Add patch doxygen_use_epoch...: Set the doxygen files data to 
      SOURCE_DATA_EPOCH if it is set with cmake.

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 15 Oct 2015 15:54:28 +0200

elastix (4.8-1) unstable; urgency=medium

  * New upstram version 
  * update patch build-static-ann.patch
  * d/copyright: Update upstream license (now Apache-2.0) 
  * d/control: - remove unused shlib:depends on elastix-doc 
               - add dependency on libjs-jquery 
               - update standards version 
  * d/rules: - remove jquery.js and *.md5 from the packaged doc files 
             - add -fvisibility=hidden as c++ flags to silence warnings 
  * Add patch to change Doxygen output: 
    - use svg graphics instead of png to save space 
    - remove time stamps from documentation 

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 12 Oct 2015 22:22:54 +0200
