=== debian/watch ===
version=4

opts=uversionmangle=s/0*(\d+)_(\d+)/$1.$2/ \
  https://github.com/SuperElastix/elastix/releases .*/archive/elastix_(\d[\d.-_]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
